//Express Routing 
var auth	= require('../lib/auth-passport');
var system  = require('../lib/dle-system');
var config  = require('../config/settings.json');

//namespacing to protect module variables
//access like this alert(index.embedded);
//other apps can call it the sameway but need to 
//be later in the js load order
var index = (function () {

	var route = config.nodeStartUp.protocol==='server'?'DSLogonEducation':'dle';

	return {
		route: route
	};
	
} )(); //end of namespace
system.logger.warn('index route: '+index.route);

exports.dle = function(req, res){   //called by app.js
  	res.render('index');			//renders ./views/index.ejs template
  	res.flush(); //this maybe needed everywhere to utilize compression
};

/** test using -> https://127.0.0.1/dle/help/auth  **/
exports.helpPage = function(req, res) {
	system.logger.info('redirect to page: '+req.params.page);
	
	/** test session content 
	system.logger.trace('saved session: '+req.session.testSession);
	//req.session.destroy();
	//delete req.session;
	var date = new Date();
	var dateStr = date.getTime(); 
	req.session.testSession = dateStr;
	system.logger.trace('saving session: '+req.session.testSession);
	**/
	
 	res.redirect("/"+index.route+"/#"+req.params.page);
};

//oAuth entry point from the client for full screen 
exports.authProvider = auth.passport.authenticate('provider');
  	
exports.dleFailure = function(req, res) {
	
	system.logger.trace('/dle/failure');
	if (auth.errors.length<1) {
		auth.errors.push(['6', 'Authentication has Failed ']);
	}

	var exceptions = auth.errors;
	system.logger.trace('auth.errors reset');						
  	auth.errors = [];

    //if ( req.sessionID ) {
    if ( auth.userAccessToken ) {
    	system.logger.trace('/dle/failure issue logout user');
        req.session.exceptions = exceptions;
        res.redirect(config.iamConnInfo.tokenLogoutUrl);
    } else {
        system.logger.trace('/dle/failure return');                                                                                             
        res.render('index', {errors: exceptions});  //render views/index.ejs -- with 'errors' parameter
    }

	//res.render('index', {errors: exceptions});  //render views/index.ejs -- with 'errors' parameter
};  	

exports.dleSuccessToken = function(req, res) {
	
	system.logger.trace('/dle/iam/success/token');	
	system.logger.info('raw dle loa: ' + auth.userProfileJson.lvlofassurance);
	system.logger.info('raw dle name: ' + auth.userProfileJson.username);
	
	//returned name: id=helen.cole,ou=user,o=beneficiaries,dc=osd,dc=mil
 	var username = auth.userProfileJson.username;
 	if (typeof username == 'undefined') {
    	username = null;
   	}
  
   	if (username) {
    	username = username.split(",");
    	username = username[0].substr(3);
   	}
 	system.logger.info('converted dle name: ' + username); 

  	req.session.username = username;
  	
  	var loa = auth.userProfileJson.lvlofassurance;
  	if ((typeof loa == 'undefined') || (loa==null)) {
    	loa = '';
   	}
  	req.session.loa = loa;
  	
  	system.logger.info('dleSuccessToken req.session.username: '+req.session.username);
  	system.logger.info('dleSuccessToken req.session.loa: '+req.session.loa);
  	
  	res.redirect(config.iamConnInfo.tokenLogoutUrl);

	/** return for logout location changes
  	res.render('index', {access: auth.userProfileJson.loa, 
  		name: auth.userProfileJson.username});
  	**/
};

exports.dleAuthLogout = function(req, res) {
	
	system.logger.trace('/dle/iam/auth/logout');
	
	var exceptions = req.session.exceptions;
	var username = req.session.username;
	var loa = req.session.loa;
	req.session.destroy();
	delete req.session;
	
	 if ( exceptions ) {
        system.logger.info('/dle/auth/logout exceptions');
        res.render('index', {errors: exceptions});  //render views/index.ejs -- with 'errors' parameter
     } else {
        system.logger.info('/dle/auth/logout dle name: ' + username);
        system.logger.info('/dle/auth/logout dle loa: ' + loa);               
        res.render('index', {access: loa, name: String(username)});  // render viewes/index.ejs -- with 'access' parameter
     }

};
